
import Prelude hiding (init)

import Polynomial
import Ideal
import Synthesis

{-

procedure gcd_lcm(x1, x2):
    y1 = x1
    y2 = x2
    y3 = x2
    y4 = 0
    while (y1 != y2):
        while (y1 > y2):
            y1 = y1 - y2
            y4 = y4 + y3
        while (y2 > y1):
            y2 = y2 - y1
            y3 = y3 + y4
    gcd = y1
    lcm = y3 + y4

-}

-- | Program variables
x1, x1', x2, x2', y1, y1', y2, y2', y3, y3', y4, y4' :: (Eq t, Num t) => Polynomial t
x1  = var "x1"
x1' = var "'x1"
x2  = var "x2"
x2' = var "'x2"
y1  = var "y1"
y1' = var "'y1"
y2  = var "y2"
y2' = var "'y2"
y3  = var "y3"
y3' = var "'y3"
y4  = var "y4"
y4' = var "'y4"

-- | Initial state, exit and post condition, and transitions
init = ideal [ y1 - x1, y2 - x2, y3 - x2, y4 ]
exit = ideal [ y1 - y2 ]
post = ideal [ y1 * (y3 + y4) - x1*x2 ]
t1 = ideal [ x1' - x1, x2' - x2, y1' - y1 + y2, y4' - y4 - y3, y2' - y2, y3' - y3 ]
t2 = ideal [ x1' - x1, x2' - x2, y2' - y2 + y1, y3' - y3 - y4, y1' - y1, y4' - y4 ]
transitions = [t1, t2]

main = dosynthesis 1 init exit post transitions [] d ["x1", "x2", "y1", "y2", "y3", "y4"]
       where d = 2 -- degree of the template polynomial
